=== debian/changelog ===
ldc (1:1.41.0-1) unstable; urgency=medium

  * New upstream version: 1.41.0
    - Fixes build with CMake 4 (Closes: #1113096)
  * Refresh patches
  * Adjust for new Phobos ABI (111)
  * Override Lintian error in source package about failing to
    unpack a fake .a file from the testsuite

 -- Matthias Klumpp <mak@debian.org>  Sat, 25 Oct 2025 20:10:36 +0200

ldc (1:1.40.0-5) unstable; urgency=medium

  [ Zixing Liu ]
  * d/control: mark libphobos2-ldc-shared-dev as M-A: same
  * d/p/05_cf_protection_attr_fix.patch: add a patch to
    fix control-flow protection attribute marking mechanism
  * d/p/06_mips_default_target.patch: add a patch to set Debian's
    MIPS64 ABI as the default MIPS64 output ABI for LDC

  [ Gianfranco Costamagna ]
  * Team upload

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 08 Feb 2025 16:59:58 +0100

ldc (1:1.40.0-4) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Team upload.

  [ Zixing Liu ]
  * d/rules: fix the build regression in the previous revision
    by using the new option --dwarf-version instead of -gdwarf.
    Also encode the D compiler flags using CMake array syntax
    as the build script expect a CMake array, not a plain string.

 -- Zixing Liu <zixing.liu@canonical.com>  Tue, 21 Jan 2025 10:08:47 -0700

ldc (1:1.40.0-3) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Team upload.

  [ Zixing Liu ]
  * d/rules: append LDC compiler flags to the stage1 build
  * d/control: add zlib1g-dev as runtime dependency
    for libphobos2-ldc-shared-dev (Closes: #1092040)

 -- Zixing Liu <zixing.liu@canonical.com>  Mon, 20 Jan 2025 15:40:28 -0700
